# coding: utf-8

"""
    Pure Storage FlashBlade REST 1.12 Python SDK

    Pure Storage FlashBlade REST 1.12 Python SDK. Compatible with REST API versions 1.0 - 1.12. Developed by [Pure Storage, Inc](http://www.purestorage.com/). Documentations can be found at [purity-fb.readthedocs.io](http://purity-fb.readthedocs.io/).

    OpenAPI spec version: 1.12
    Contact: info@purestorage.com
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


import pprint
import re  # noqa: F401

import six


class FileSystemPatch(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

#BEGIN_CUSTOM
    # IR-51527: Prevent Pytest from attempting to collect this class based on name.
    __test__ = False
#END_CUSTOM

    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'default_user_quota': 'int',
        'default_group_quota': 'int',
        'destroyed': 'bool',
        'fast_remove_directory_enabled': 'bool',
        'hard_limit_enabled': 'bool',
        'http': 'ProtocolRule',
        'multi_protocol': 'MultiProtocolRule',
        'nfs': 'NfsRulePatch',
        'provisioned': 'int',
        'requested_promotion_state': 'str',
        'smb': 'SmbRule',
        'snapshot_directory_enabled': 'bool',
        'writable': 'bool'
    }

    attribute_map = {
        'default_user_quota': 'default_user_quota',
        'default_group_quota': 'default_group_quota',
        'destroyed': 'destroyed',
        'fast_remove_directory_enabled': 'fast_remove_directory_enabled',
        'hard_limit_enabled': 'hard_limit_enabled',
        'http': 'http',
        'multi_protocol': 'multi_protocol',
        'nfs': 'nfs',
        'provisioned': 'provisioned',
        'requested_promotion_state': 'requested_promotion_state',
        'smb': 'smb',
        'snapshot_directory_enabled': 'snapshot_directory_enabled',
        'writable': 'writable'
    }

    def __init__(self, default_user_quota=None, default_group_quota=None, destroyed=None, fast_remove_directory_enabled=None, hard_limit_enabled=None, http=None, multi_protocol=None, nfs=None, provisioned=None, requested_promotion_state=None, smb=None, snapshot_directory_enabled=None, writable=None):  # noqa: E501
        """FileSystemPatch - a model defined in Swagger"""  # noqa: E501

        self._default_user_quota = None
        self._default_group_quota = None
        self._destroyed = None
        self._fast_remove_directory_enabled = None
        self._hard_limit_enabled = None
        self._http = None
        self._multi_protocol = None
        self._nfs = None
        self._provisioned = None
        self._requested_promotion_state = None
        self._smb = None
        self._snapshot_directory_enabled = None
        self._writable = None
        self.discriminator = None

        if default_user_quota is not None:
            self.default_user_quota = default_user_quota
        if default_group_quota is not None:
            self.default_group_quota = default_group_quota
        if destroyed is not None:
            self.destroyed = destroyed
        if fast_remove_directory_enabled is not None:
            self.fast_remove_directory_enabled = fast_remove_directory_enabled
        if hard_limit_enabled is not None:
            self.hard_limit_enabled = hard_limit_enabled
        if http is not None:
            self.http = http
        if multi_protocol is not None:
            self.multi_protocol = multi_protocol
        if nfs is not None:
            self.nfs = nfs
        if provisioned is not None:
            self.provisioned = provisioned
        if requested_promotion_state is not None:
            self.requested_promotion_state = requested_promotion_state
        if smb is not None:
            self.smb = smb
        if snapshot_directory_enabled is not None:
            self.snapshot_directory_enabled = snapshot_directory_enabled
        if writable is not None:
            self.writable = writable

    @property
    def default_user_quota(self):
        """Gets the default_user_quota of this FileSystemPatch.  # noqa: E501

        Default quota for a user under this file system. Modifiable. Default is 0, meaning no quota, when creating a new file-system.  # noqa: E501

        :return: The default_user_quota of this FileSystemPatch.  # noqa: E501
        :rtype: int
        """
        return self._default_user_quota

    @default_user_quota.setter
    def default_user_quota(self, default_user_quota):
        """Sets the default_user_quota of this FileSystemPatch.

        Default quota for a user under this file system. Modifiable. Default is 0, meaning no quota, when creating a new file-system.  # noqa: E501

        :param default_user_quota: The default_user_quota of this FileSystemPatch.  # noqa: E501
        :type: int
        """

        self._default_user_quota = default_user_quota

    @property
    def default_group_quota(self):
        """Gets the default_group_quota of this FileSystemPatch.  # noqa: E501

        Default quota for a group under this file system. Modifiable. Default is 0, meaning no quota, when creating a new file-system.  # noqa: E501

        :return: The default_group_quota of this FileSystemPatch.  # noqa: E501
        :rtype: int
        """
        return self._default_group_quota

    @default_group_quota.setter
    def default_group_quota(self, default_group_quota):
        """Sets the default_group_quota of this FileSystemPatch.

        Default quota for a group under this file system. Modifiable. Default is 0, meaning no quota, when creating a new file-system.  # noqa: E501

        :param default_group_quota: The default_group_quota of this FileSystemPatch.  # noqa: E501
        :type: int
        """

        self._default_group_quota = default_group_quota

    @property
    def destroyed(self):
        """Gets the destroyed of this FileSystemPatch.  # noqa: E501

        Is the file system destroyed? False by default. Modifiable.  # noqa: E501

        :return: The destroyed of this FileSystemPatch.  # noqa: E501
        :rtype: bool
        """
        return self._destroyed

    @destroyed.setter
    def destroyed(self, destroyed):
        """Sets the destroyed of this FileSystemPatch.

        Is the file system destroyed? False by default. Modifiable.  # noqa: E501

        :param destroyed: The destroyed of this FileSystemPatch.  # noqa: E501
        :type: bool
        """

        self._destroyed = destroyed

    @property
    def fast_remove_directory_enabled(self):
        """Gets the fast_remove_directory_enabled of this FileSystemPatch.  # noqa: E501

        Is fast remove directory enabled? Modifiable. Default false when creating a new file-system.  # noqa: E501

        :return: The fast_remove_directory_enabled of this FileSystemPatch.  # noqa: E501
        :rtype: bool
        """
        return self._fast_remove_directory_enabled

    @fast_remove_directory_enabled.setter
    def fast_remove_directory_enabled(self, fast_remove_directory_enabled):
        """Sets the fast_remove_directory_enabled of this FileSystemPatch.

        Is fast remove directory enabled? Modifiable. Default false when creating a new file-system.  # noqa: E501

        :param fast_remove_directory_enabled: The fast_remove_directory_enabled of this FileSystemPatch.  # noqa: E501
        :type: bool
        """

        self._fast_remove_directory_enabled = fast_remove_directory_enabled

    @property
    def hard_limit_enabled(self):
        """Gets the hard_limit_enabled of this FileSystemPatch.  # noqa: E501

        Is the file system's size a hard limit quota. Modifiable. Default is false.  # noqa: E501

        :return: The hard_limit_enabled of this FileSystemPatch.  # noqa: E501
        :rtype: bool
        """
        return self._hard_limit_enabled

    @hard_limit_enabled.setter
    def hard_limit_enabled(self, hard_limit_enabled):
        """Sets the hard_limit_enabled of this FileSystemPatch.

        Is the file system's size a hard limit quota. Modifiable. Default is false.  # noqa: E501

        :param hard_limit_enabled: The hard_limit_enabled of this FileSystemPatch.  # noqa: E501
        :type: bool
        """

        self._hard_limit_enabled = hard_limit_enabled

    @property
    def http(self):
        """Gets the http of this FileSystemPatch.  # noqa: E501

        HTTP configuration. Modifiable.  # noqa: E501

        :return: The http of this FileSystemPatch.  # noqa: E501
        :rtype: ProtocolRule
        """
        return self._http

    @http.setter
    def http(self, http):
        """Sets the http of this FileSystemPatch.

        HTTP configuration. Modifiable.  # noqa: E501

        :param http: The http of this FileSystemPatch.  # noqa: E501
        :type: ProtocolRule
        """

        self._http = http

    @property
    def multi_protocol(self):
        """Gets the multi_protocol of this FileSystemPatch.  # noqa: E501

        Configuration options governing the interactions of different protocols when multiple are enabled on the file system.  # noqa: E501

        :return: The multi_protocol of this FileSystemPatch.  # noqa: E501
        :rtype: MultiProtocolRule
        """
        return self._multi_protocol

    @multi_protocol.setter
    def multi_protocol(self, multi_protocol):
        """Sets the multi_protocol of this FileSystemPatch.

        Configuration options governing the interactions of different protocols when multiple are enabled on the file system.  # noqa: E501

        :param multi_protocol: The multi_protocol of this FileSystemPatch.  # noqa: E501
        :type: MultiProtocolRule
        """

        self._multi_protocol = multi_protocol

    @property
    def nfs(self):
        """Gets the nfs of this FileSystemPatch.  # noqa: E501

        NFS configuration. Modifiable.  # noqa: E501

        :return: The nfs of this FileSystemPatch.  # noqa: E501
        :rtype: NfsRulePatch
        """
        return self._nfs

    @nfs.setter
    def nfs(self, nfs):
        """Sets the nfs of this FileSystemPatch.

        NFS configuration. Modifiable.  # noqa: E501

        :param nfs: The nfs of this FileSystemPatch.  # noqa: E501
        :type: NfsRulePatch
        """

        self._nfs = nfs

    @property
    def provisioned(self):
        """Gets the provisioned of this FileSystemPatch.  # noqa: E501

        The provisioned size of the file system in bytes. Modifiable. Default is 0 when creating a new file-system.  # noqa: E501

        :return: The provisioned of this FileSystemPatch.  # noqa: E501
        :rtype: int
        """
        return self._provisioned

    @provisioned.setter
    def provisioned(self, provisioned):
        """Sets the provisioned of this FileSystemPatch.

        The provisioned size of the file system in bytes. Modifiable. Default is 0 when creating a new file-system.  # noqa: E501

        :param provisioned: The provisioned of this FileSystemPatch.  # noqa: E501
        :type: int
        """

        self._provisioned = provisioned

    @property
    def requested_promotion_state(self):
        """Gets the requested_promotion_state of this FileSystemPatch.  # noqa: E501

        Possible values are `promoted` and `demoted`. The `demoted` state is used for replication targets and is only allowed to be set if the file system is in a replica-link relationship. The additional query param `discard-non-snapshotted-data` must be set to `true` when demoting a file system. The default for new file systems is `promoted`.  # noqa: E501

        :return: The requested_promotion_state of this FileSystemPatch.  # noqa: E501
        :rtype: str
        """
        return self._requested_promotion_state

    @requested_promotion_state.setter
    def requested_promotion_state(self, requested_promotion_state):
        """Sets the requested_promotion_state of this FileSystemPatch.

        Possible values are `promoted` and `demoted`. The `demoted` state is used for replication targets and is only allowed to be set if the file system is in a replica-link relationship. The additional query param `discard-non-snapshotted-data` must be set to `true` when demoting a file system. The default for new file systems is `promoted`.  # noqa: E501

        :param requested_promotion_state: The requested_promotion_state of this FileSystemPatch.  # noqa: E501
        :type: str
        """

        self._requested_promotion_state = requested_promotion_state

    @property
    def smb(self):
        """Gets the smb of this FileSystemPatch.  # noqa: E501

        SMB configuration. Modifiable.  # noqa: E501

        :return: The smb of this FileSystemPatch.  # noqa: E501
        :rtype: SmbRule
        """
        return self._smb

    @smb.setter
    def smb(self, smb):
        """Sets the smb of this FileSystemPatch.

        SMB configuration. Modifiable.  # noqa: E501

        :param smb: The smb of this FileSystemPatch.  # noqa: E501
        :type: SmbRule
        """

        self._smb = smb

    @property
    def snapshot_directory_enabled(self):
        """Gets the snapshot_directory_enabled of this FileSystemPatch.  # noqa: E501

        Is snapshot directory enabled? Modifiable. Default false when creating a new file-system.  # noqa: E501

        :return: The snapshot_directory_enabled of this FileSystemPatch.  # noqa: E501
        :rtype: bool
        """
        return self._snapshot_directory_enabled

    @snapshot_directory_enabled.setter
    def snapshot_directory_enabled(self, snapshot_directory_enabled):
        """Sets the snapshot_directory_enabled of this FileSystemPatch.

        Is snapshot directory enabled? Modifiable. Default false when creating a new file-system.  # noqa: E501

        :param snapshot_directory_enabled: The snapshot_directory_enabled of this FileSystemPatch.  # noqa: E501
        :type: bool
        """

        self._snapshot_directory_enabled = snapshot_directory_enabled

    @property
    def writable(self):
        """Gets the writable of this FileSystemPatch.  # noqa: E501

        -> Is the file system writable? True by default. Cannot be True when `promoted` is False.  # noqa: E501

        :return: The writable of this FileSystemPatch.  # noqa: E501
        :rtype: bool
        """
        return self._writable

    @writable.setter
    def writable(self, writable):
        """Sets the writable of this FileSystemPatch.

        -> Is the file system writable? True by default. Cannot be True when `promoted` is False.  # noqa: E501

        :param writable: The writable of this FileSystemPatch.  # noqa: E501
        :type: bool
        """

        self._writable = writable

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(FileSystemPatch, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, FileSystemPatch):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
